program DARTS (input,output, infile, outfile);
const
   Max_Pos = 20;      {Number of positions on dart board}
   Min     =  0;      {Minimum score}
var
   Dart1, Dart2, Dart3, Score, Pcount, Count  : integer;
   Possible_Scores : set of 0..3 * Max_Pos;
   infile, outfile : text;

function Minimum(i,j:integer):integer;
    begin
       if i <= j then
          Minimum := i
       else
          Minimum := j;
    end;

begin
   { assign (infile,'DARTS.IN'); }
   { assign (outfile,'DARTS.OUT'); }
   reset(infile, 'darts.in' );
   rewrite(outfile, 'darts.out' );

   {Assign members to the set}
   Possible_Scores := [50];
   for Dart1 := Min to Max_Pos do begin
      Possible_Scores := Possible_Scores + [Dart1];
      Possible_Scores := Possible_Scores + [Dart1 * 2];
      Possible_Scores := Possible_Scores + [Dart1 * 3];
   end;

   readln(infile,Score);
   while (Score > 0) do begin
      writeln('Evaluating Score = ',Score:1);
      Pcount := 0;
      Count := 0;

      if Score <= 180 then begin
         {Combination calculation}
         for Dart1 := Min to Minimum(Score,Max_Pos * 3) do begin
            for Dart2  := Dart1 to Minimum(Score-Dart1,Max_Pos * 3) do begin
               for Dart3 := Dart2 to Minimum(Score-Dart1-Dart2,Max_Pos * 3) do begin
                  if ((Dart1 in Possible_Scores) and
                      (Dart2 in Possible_Scores) and
                      (Dart3 in Possible_Scores) and
                      (Dart1 + Dart2 + Dart3 = Score)) then
                  begin
                     Count := Count + 1;
                  end;
               end;
            end;
         end;

         {Permutation calculation}
         if (Count <> 0) then begin
            for Dart1 := Min to Minimum(Score,Max_Pos * 3) do begin
               for Dart2 := Min to Minimum(Score,Max_Pos * 3) do begin
                  for Dart3 := Min to Minimum(Score,Max_Pos * 3) do begin
                     if ((Dart1 in Possible_Scores) and
                         (Dart2 in Possible_Scores) and
                         (Dart3 in Possible_Scores) and
                         (Dart1 + Dart2 + Dart3 = Score)) then
                     begin
                        Pcount := Pcount + 1;
                     end;
                  end;
               end;
            end;
         end;
      end;
      {Report results}
      if (Count <> 0) then begin
         write  (outfile,'NUMBER OF COMBINATIONS THAT SCORES ',Score:1);
         writeln(outfile,' is ',Count:1,'.');
         write  (outfile,'NUMBER OF PERMUTATIONS THAT SCORES ',Score:1);
         writeln(outfile,' is ',Pcount:1,'.');
      end else begin
         write  (outfile,'THE SCORE OF ',Score:1);
         writeln(outfile,' CANNOT BE MADE WITH THREE DARTS.');
      end;
      write(outfile,'**************************************************');
      writeln(outfile,'********************');

      readln(infile,Score);
   end;

   writeln(outfile,'END OF OUTPUT');
   close(infile);
   close(outfile);
end.
